' entry point of EpisodesListItemComponent
sub Init()
    ' store components to m for populating them with metadata
    m.poster = m.top.FindNode("poster")
    m.title = m.top.FindNode("title")
    m.description = m.top.FindNode("description")

    m.info = m.top.FindNode("info")
    setFont(m.info, ["GothamWhite16"])    

    ' set font size for title and description Labels
    m.title.font.size = 20
    m.description.font.size = 16    
end sub

sub itemContentChanged() ' invoked when episode data is retrieved
    itemContent = m.top.itemContent ' episode metadata
    if itemContent <> invalid
        ' populate components with metadata
        m.poster.uri = itemContent.hdPosterUrl
        m.title.text = itemContent.title
        divider = " | "
        episode = "E" + itemContent.episodePosition
        time = GetTime(itemContent.length)
        date = itemContent.releaseDate
        m.info.text = "<GothamWhite16>" + episode + divider + date + divider + time

        vote = []
        if VoteHasBeenCast(itemContent.id, vote) = true
            ' Add a 'vote' field if it does not exist.
            if itemContent.vote = invalid
                itemContent.addFields( { "vote": "" } )
            end if
            itemContent.vote = vote[0]
        end if

        if itemContent.vote <> invalid
            if itemContent.vote = "Like"
                m.info.text += divider + "Liked"
            else
                m.info.text += divider + "Disliked"
            end if
        end if

        m.info.text += "</GothamWhite16>"

        m.description.text = itemContent.description
    end if
end sub
'//# sourceMappingURL=./EpisodesListItemComponent.brs.map