'import "pkg:/components/UILogic/ScreenStackLogic.bs"

' entry point of MainScene
sub Init()
    ' Set background color for scene.  Applied only if backgroundUri has empty value.
    m.top.backgroundColor = GetValueFromManifest("BACKGROUND_COLOR")
    backgroundImage = GetValueFromManifest("BACKGROUND_IMAGE")
    ' If background image is supplied, use it.
    if backgroundImage <> ""
        m.background = m.top.findNode("background")
        m.background.uri = backgroundImage
    else
        m.top.backgroundUri = ""
    end if
    m.loadingIndicator = m.top.FindNode("loadingIndicator") ' store loadingIndicator to m
    ' Initialize the screen stack.
    InitScreenStack()
    ' Show the grid screen.
    ShowGridScreen()
    ' Collect the content from the feed file.
    LoadChannelContent()
    ' Create a ChannelStore object and attach it to the global node.
    m.global.AddField("channelStore", "node", false)
    m.global.channelStore = CreateObject("roSGNode", "ChannelStore")
    ' DEBUG ONLY - Remove Roku cloud token.
    'm.global.channelStore.channelCredData = ""
    'm.global.channelStore.command = "storeChannelCredData"
    ' DEBUG ONLY
end sub

'   The OnKeyEvent() function receives remote control key events.
function OnKeyEvent(key as String, press as Boolean) as Boolean
    result = false
    if press
        ' handle "back" key press.
        if key = "back"
            numberOfScreens = m.ScreenStack.appscreenStack.Count()
            ' close top screen if there are two or more screens in the screen stack.
            if numberOfScreens > 1
                CloseScreen(invalid)
                result = true
            end if
            ' handle "options" key press for search
        else if key = "options"
            search = GetValueFromManifest("ALLOW_CHANNEL_SEARCH")
            if search = "true"
                ShowSearchScreen()
            end if
        end if
    end if
    ' The OnKeyEvent() function must return true if the component handled the event,
    ' or false if it did not handle the event.
    return result
end function

'''''''''
' GetScreenStack: Gets the screen stack componenet in those situations where the 'm' context is incorrect.
' 
' @param {dynamic} I: _parm - needed by callfunc().
' @return {object} - returns the screen stack component.
'''''''''
function GetScreenStack(_parm as dynamic) as object
    return m.screenStack
end function'//# sourceMappingURL=./MainScene.bs.map