sub Init()
    ' List of Subscription server resources.  You MUST update the URLs to point to YOUR Subscritpion Server Rest API.
    m.SubscriptionServerResources = {
        "validate-token": "https://0pqd7rbzdk.execute-api.us-east-1.amazonaws.com/Test/validate-token"
        "check-linked-subscription": "https://9vxf5xj73k.execute-api.us-east-1.amazonaws.com/Test/check-linked-subscription"
        "validate-credentials": "https://g650udxzqe.execute-api.us-east-1.amazonaws.com/Test/validate-credentials"
        "get-access-token": "https://c7e1cfe5sg.execute-api.us-east-1.amazonaws.com/Test/get-access-token"
        "validate-new-order": "https://z38xor1wg3.execute-api.us-east-1.amazonaws.com/Test/validate-new-order"
        "check-entitlement": "https://1j6xlg6vxf.execute-api.us-east-1.amazonaws.com/Test/check-entitlement"
    }
    ' Create url transefer object.
    m.xfer = CreateObject("roURLTransfer")
    m.xfer.SetCertificatesFile("common:/certs/ca-bundle.crt")
    ' set the name of the function in the Task node component to be executed when the state field changes to RUN.
    m.top.functionName = "CallSubscriptionAPI"
end sub

'''''''''
' CallSubscriptionAPI: Execute the Subscription server API call.
' 
'''''''''
sub CallSubscriptionAPI()
    ' Set the URL to the Subscription sever with the associated endpoint.
    SubscriptionServerEndpointUrl = m.SubscriptionServerResources[m.top.endpoint]
    if m.top.endpoint = "validate-token"
        RestUrl = SubscriptionServerEndpointUrl + "?accessToken=" + m.top.accessToken
    else if m.top.endpoint = "check-linked-subscription"
        RestUrl = SubscriptionServerEndpointUrl + "?email=" + m.top.email
    else if m.top.endpoint = "validate-credentials"
        RestUrl = SubscriptionServerEndpointUrl + "?email=" + m.top.email + "&password=" + m.top.password
    else if m.top.endpoint = "get-access-token"
        RestUrl = SubscriptionServerEndpointUrl
    else if m.top.endpoint = "validate-new-order"
        RestUrl = SubscriptionServerEndpointUrl + "?email=" + m.top.email + "&firstname=" + m.top.firstname + "&lastname=" + m.top.lastname
    else if m.top.endpoint = "check-entitlement"
        RestUrl = SubscriptionServerEndpointUrl + "?transid=" + m.top.transid
    end if
    m.xfer.SetURL(RestUrl)
    ' Return a JSON response.
    m.xfer.AddHeader("accept", "application/json")
    rsp = m.xfer.GetToString()
    json = ParseJson(rsp)
    m.top.response = json
end sub'//# sourceMappingURL=./SubscriptionServerApiTask.bs.map