' Font support functions.
' (c) Copyright 2023, Michael Harnad

'''''''''
' setFont: Sets the font of the passed object.
' 
' @param {object} I: _object - the object MUST support drawingStyles.
' @param {string} I: _fontNames - array of font names to use.
' @return {dynamic}
'''''''''
function setFont(_object as object, _fontNames as object)
    objectStyle = {}
    availableFonts = {
        "GothamBoldDarkBlue": {
            "fontUri": "pkg:/fonts/Gotham-Bold.otf"
            "fontSize": 36
            "color": "#00008b"
        }
        "GothamWhite": {
            "fontUri": "pkg:/fonts/Gotham-Medium.otf"
            "fontSize": 36
            "color": "#FFFAFA"
        }
        "GothamWhite12": {
            "fontUri": "pkg:/fonts/Gotham-Medium.otf"
            "fontSize": 12
            "color": "#FFFAFA"
        }
        "GothamWhite16": {
            "fontUri": "pkg:/fonts/Gotham-Medium.otf"
            "fontSize": 16
            "color": "#FFFAFA"
        }
        "GothamDarkBlue12": {
            "fontUri": "pkg:/fonts/Gotham-Medium.otf"
            "fontSize": 12
            "color": "#00008b"
        }
        "GothamDarkBlue18": {
            "fontUri": "pkg:/fonts/Gotham-Medium.otf"
            "fontSize": 18
            "color": "#00008b"
        }
        "LobsterLarge": {
            "fontUri": "pkg:/fonts/Lobster.otf"
            "fontSize": 36
            "color": "#FFFAFA"
        }
        "NordicaClassicLightItalic": {
            "fontUri": "pkg:/fonts/NordicaClassicLightCondensedOblique.otf"
            "fontSize": 18
            "color": "#00008b"
        }
        "GenericDingbatsSmall": {
            "fontUri": "pkg:/fonts/genericons.regular.otf"
            "fontSize": 12
            "color": "#00008b"
        }
        "default": {
            "fontSize": 36
            "fontUri": "font:LargeSystemFont"
            "color": "#DDDDDDFF"
        }
    }
    ' Make sure the object and the font name are valid.
    if _object <> invalid and _fontNames <> invalid
        for each font in _fontNames
            objectStyle[font] = availableFonts[font]
        end for
        _object.drawingStyles = objectStyle
    end if
end function'//# sourceMappingURL=./fontsupport.bs.map